package com.jtricks;

import org.springframework.beans.factory.DisposableBean;
import org.springframework.beans.factory.InitializingBean;

import com.atlassian.event.api.EventListener;
import com.atlassian.event.api.EventPublisher;
import com.atlassian.jira.event.issue.IssueEvent;
import com.atlassian.jira.util.ComponentLocator;
import com.atlassian.jira.util.JiraDurationUtils;
import com.atlassian.sal.api.user.UserManager;

public class IssueListener implements InitializingBean, DisposableBean {
	
	private final EventPublisher eventPublisher;

	public IssueListener(EventPublisher eventPublisher, UserManager userManager, JiraDurationUtils jiraDurationUtils, ComponentLocator componentLoator) {
		super();
		this.eventPublisher = eventPublisher;
	}

	@Override
	public void destroy() throws Exception {
		eventPublisher.unregister(this);
	}

	@Override
	public void afterPropertiesSet() throws Exception {
		eventPublisher.register(this);
	}
	
	@EventListener
    public void onIssueEvent(IssueEvent issueEvent) {
		System.out.println("Wow, an issue event on "+issueEvent.getIssue().getKey());
	}

}
